Attribute VB_Name = "mTray"
'Copyright (C) 2008 takuya
'License: GPL v2 or later (read "LICENSE")
'̃R[h̃CZX́AGPL v2܂͂ȍ~łB

Option Explicit

'--mTray.bas
'gCo^e

'gCACRf[^-----------------------------------------------------------
Private Type NOTIFYICONDATA
        cbSize As Long
        hWnd As Long
        uID As Long
        uFlags As enumShellNotifyIconFlag
        uCallbackMessage As Long
        hIcon As Long
        szTip As String * 128
        dwState As Long
        dwStateMask As Long
        szInfo As String * 256
        uTimeout As Long
        szInfoTitle As String * 64
        dwInfoFlags As Long
End Type

Private Declare Function Shell_NotifyIcon Lib "shell32.dll" _
        Alias "Shell_NotifyIconA" _
        (ByVal dwMessage As enumShellNotifyIconMessage, lpData As NOTIFYICONDATA) As Long
        
'EXEACR擾
Private Declare Function ExtractIconEx Lib "shell32.dll" Alias "ExtractIconExA" (ByVal lpszFile As String, ByVal nIconIndex As Long, phiconLarge As Long, phiconSmall As Long, ByVal nIcons As Long) As Long
'ACR폜
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long

'ɐ錾Ă̂ŕsv
'Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
'Public Declare Function timeGetTime Lib "WINMM" () As Long

'o^-----------------------------------------------------------------------
Private Enum enumShellNotifyIconMessage
    NIM_ADD = &H0&
    NIM_MODIFY = &H1&
    NIM_DELETE = &H2&
    NIM_SETVERSION = &H4&
End Enum

'o^e-----------------------------------------------------------------------
Private Enum enumShellNotifyIconFlag
    NIF_MESSAGE = &H1
    NIF_ICON = &H2
    NIF_TIP = &H4
    NIF_INFO = &H10
End Enum

'R[obN-------------------------------------------------------------------
Private Const WM_MOUSEMOVE = &H200

'WM_MOUSEMOVEŗXl̔------------------------------------------------
Public Const TRAY_MOVE As Long = &H200
Public Const TRAY_LEFT_DOWN As Long = &H201
Public Const TRAY_LEFT_UP As Long = &H202
Public Const TRAY_LEFT_DOUBLE As Long = &H203
'Public Const TRAY_RIGHT_DOWN As Long = 7740
'Public Const TRAY_RIGHT_UP As Long = 7755
'Public Const TRAY_RIGHT_DOUBLE As Long = 7770
Public Const TRAY_RIGHT_DOWN As Long = &H204
Public Const TRAY_RIGHT_UP As Long = &H205
Public Const TRAY_RIGHT_DOUBLE As Long = &H206
Public Const TRAY_CENTER_DOWN As Long = &H207
Public Const TRAY_CENTER_UP As Long = &H208
Public Const TRAY_CENTER_DOUBLE As Long = &H209
Public Const TRAY_BALOON_POPUP As Long = 15390
Public Const TRAY_BALOON_CLOSE As Long = 15420
Public Const TRAY_BALOON_CLICK As Long = 15435

Private udtNotifyIconData As NOTIFYICONDATA
Public hOldIcon As Long

Public Sub iconADD(hIconr As Long, hWndr As Long, hTips As String)
  Dim Tip()   As Byte, i As Long, l As Long
  Dim LIcon As Long, SIcon As Long
  hOldIcon = hIconr
  Call ExtractIconEx(IIf(Right$(App.Path, 1) = "\", App.Path, App.Path & "\") & App.EXEName & ".exe", hIconr, LIcon, SIcon, 1)
  With udtNotifyIconData
    .uCallbackMessage = WM_MOUSEMOVE
    .cbSize = Len(udtNotifyIconData)
    .hIcon = SIcon
    .hWnd = hWndr
    .uID = 1
    .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
    .szTip = hTips & vbNullChar
  End With
reADD:
  i = Shell_NotifyIcon(NIM_ADD, udtNotifyIconData)
  If i = 0 Then
      l = l + 1
      If l >= 5 Then GoTo addDestroy
    Sleep3 2000
    GoTo reADD
  End If
addDestroy:
  Call DestroyIcon(LIcon): Call DestroyIcon(SIcon)
End Sub

Public Sub iconMOD(Optional ByVal hIconr As Long = -1, Optional hTips As String = "")
  Dim Tip() As Byte, i As Long, l As Long
  Dim LIcon As Long, SIcon As Long
  
  With udtNotifyIconData
    If hIconr = -1 Then hIconr = hOldIcon
    If hOldIcon = IconType.A_ReceiveMessage Then hIconr = hOldIcon
    hOldIcon = hIconr
    Call ExtractIconEx(IIf(Right$(App.Path, 1) = "\", App.Path, App.Path & "\") & App.EXEName & ".exe", hIconr, LIcon, SIcon, 1)
    .hIcon = SIcon
    If hTips <> "" Then
      .szTip = "PRCP񋤗LvOC " & VERSION_TYPE & BETA_VER & "(Rev" & App.Revision - 1000 & ")" & vbCrLf & hTips & vbNullChar
    End If
  End With
  i = Shell_NotifyIcon(NIM_MODIFY, udtNotifyIconData)
  If i = 0 Then
reMOD:
    i = Shell_NotifyIcon(NIM_ADD, udtNotifyIconData)
    If i = 0 Then
        l = l + 1
        If l >= 5 Then GoTo modDestroy
      Sleep3 2000
      GoTo reMOD
    End If
  End If
modDestroy:
  Call DestroyIcon(LIcon): Call DestroyIcon(SIcon)
End Sub

Public Sub iconBAL(Optional hTitle As String = "", Optional hTips As String = "", Optional IconType As Long = 1, Optional hTime As Long = 5000)
  Dim Tip() As Byte, i As Long, l As Long
  With udtNotifyIconData
    .uFlags = NIF_INFO
    .dwInfoFlags = IconType
    .uTimeout = hTime
    If hTitle <> "" Then
      .szInfoTitle = hTitle & vbNullChar
    End If
    If hTips <> "" Then
      .szInfo = hTips & vbNullChar
    End If
  End With
  i = Shell_NotifyIcon(NIM_MODIFY, udtNotifyIconData)
  udtNotifyIconData.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
  i = Shell_NotifyIcon(NIM_MODIFY, udtNotifyIconData)
  If i = 0 Then
reBAL:
    i = Shell_NotifyIcon(NIM_ADD, udtNotifyIconData)
    If i = 0 Then
        l = l + 1
        If l >= 5 Then Exit Sub
      Sleep3 2000
      GoTo reBAL
    End If
  End If
End Sub

Public Sub iconDEL()
  Dim i As Long
  i = Shell_NotifyIcon(NIM_DELETE, udtNotifyIconData)
End Sub

'Public Sub Sleep3(lMilliSeconds As Long)
'  Dim b As Long
'  b = timeGetTime
'  Do
'    DoEvents
'    Sleep 10
'  Loop Until timeGetTime - b >= lMilliSeconds
'End Sub
