Attribute VB_Name = "mUPnPAssist"
'Copyright (C) 2008 takuya
'License: GPL v2 or later (read "LICENSE")
'̃R[h̃CZX́AGPL v2܂͂ȍ~łB

Option Explicit

'UPnPW[̐x

Private Const ERR_UPnPDeviceNotFound As Long = 1001
Private Const ERR_UPnPPortOpenError As Long = 1002
Private Const ERR_Succeed As Long = 0
Dim bOpened As Byte, cUPnP As New clUPnP

Public Function Port_Open() As Long
    cUPnP.SET_SockObject fMain.wsUPnPT, fMain.wsUPnPU
    If cUPnP.Detect = 0 Then
        If cUPnP.OpenPort(uSetting_Network.lListenPort, , , UPNP_NAME) = 0 Then bOpened = 1: Port_Open = ERR_Succeed: logger "UPnPfoCX̃|[gJ܂B" Else Port_Open = ERR_UPnPPortOpenError: logger "UPnPfoCX̃|[gJɎs܂B"
    Else
        logger "UPnPfoCX܂łB"
        Port_Open = ERR_UPnPDeviceNotFound
    End If
    If bOpened <> 1 Then cUPnP.UNSET_SockObject
End Function

Public Function Port_Close() As Long
    'Detectς݂ł邩
    If bOpened = 1 Then
        Call cUPnP.ClosePort(uSetting_Network.lListenPort, UPNP_NAME)
        bOpened = 0: cUPnP.UNSET_SockObject
    End If
    Port_Close = 0
End Function
